## ----style, echo = FALSE, results = 'asis'------------------------------------
BiocStyle::markdown()
options(width=80, max.print=1000)
knitr::opts_chunk$set(
    eval=as.logical(Sys.getenv("KNITR_EVAL", "TRUE")),
    cache=as.logical(Sys.getenv("KNITR_CACHE", "TRUE")), 
    tidy.opts=list(width.cutoff=80), tidy=TRUE)

## ----setup, echo=FALSE, messages=FALSE, warnings=FALSE------------------------
suppressPackageStartupMessages({
    library(systemPipeR)
})

## ----genRna_workflow_single, eval=FALSE---------------------------------------
#  library(systemPipeRdata)
#  genWorkenvir(workflow="rnaseq")
#  setwd("rnaseq")

## ----project_rnaseq, eval=FALSE-----------------------------------------------
#  sal <- SPRproject()
#  sal <- importWF(sal, file_path = "systemPipeRNAseq.Rmd", verbose = FALSE)

## ----run_rnaseq, eval=FALSE---------------------------------------------------
#  sal <- runWF(sal)

## ----plot_rnaseq, eval=FALSE--------------------------------------------------
#  plotWF(sal, rstudio = TRUE)

## ----report_rnaseq, eval=FALSE------------------------------------------------
#  sal <- renderReport(sal)
#  sal <- renderLogs(sal)

## ----genChip_workflow, eval=FALSE---------------------------------------------
#  library(systemPipeRdata)
#  genWorkenvir(workflow="chipseq")
#  setwd("chipseq")

## ----genVar_workflow_single, eval=FALSE---------------------------------------
#  library(systemPipeRdata)
#  genWorkenvir(workflow="varseq")
#  setwd("varseq")

## ----genRibo_workflow_single, eval=FALSE--------------------------------------
#  library(systemPipeRdata)
#  genWorkenvir(workflow="riboseq")
#  setwd("riboseq")

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

